package com.jscape.inet.ssh.protocol.v2.marshaling;

import com.jscape.inet.ssh.protocol.messages.Message;
import com.jscape.inet.ssh.protocol.v2.marshaling.primitive.StringCodec;
import com.jscape.inet.ssh.protocol.v2.marshaling.primitive.Uint32Codec;
import com.jscape.inet.ssh.protocol.v2.messages.SshMsgDisconnect;
import com.jscape.util.io.DataCodec;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

/**
 * @author Alex Usun
 */
public class SshMsgDisconnectCodec
        implements DataCodec<Message> {

    @Override
    public Message read(InputStream in)
            throws IOException {
        int reasonCode = Uint32Codec.readValue(in);
        String description = StringCodec.readUtf8Value(in);
        String languageTag = StringCodec.readUsAsciiValue(in);

        return new SshMsgDisconnect(reasonCode, description, languageTag);
    }

    @Override
    public void write(Message value, OutputStream out)
            throws IOException {
        SshMsgDisconnect message = (SshMsgDisconnect) value;
        Uint32Codec.writeValue(message.reasonCode, out);
        StringCodec.writeUtf8Value(message.description, out);
        StringCodec.writeUsAsciiValue(message.languageTag, out);
    }
}
